Configuration API Copy Link
If true, only a single range can be selected |
If true the header of cells containing ranges will be highlighted. |
If true, allows selection of a column of cells when clicking the column header. |
Determine the selection handle behaviour. Can be used to configure the range handle and the fill handle.
|
Selection Events Copy Link
A change to cell selection has occurred. |
Fill operation has started. |
Fill operation has ended. |
As an example to illustrate the cellSelectionChanged event, if selecting a range of 5 cells in a row, the user will click the first cell and drag to the last cell. This will result in up to 7 events. The first and last cell in the range will cause two events each. This is due to the first cell firing an event with started=true, finished=true upon mousedown with an additional event started=true, finished=false while in the range, and the last cell firing an event started=false, finished=false as soon as it is in the range and then again started=false, finished=true upon the end of cell selection. All the intermediary events will have one event with both started and finished as false. This is illustrated in the table:
| User action | started | finished |
|---|---|---|
mousedown in first cell | true | true |
mousemove in first cell | true | false |
mousemove in intermediate cells | false | false |
mousemove in final cell | false | false |
mouseup in final cell | false | true |
The example below also illustrates this by logging the event fields in the console:
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[rowData]="rowData"
(cellSelectionChanged)="onCellSelectionChanged($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 150 },
{ field: "age", maxWidth: 90 },
{ field: "country", minWidth: 150 },
{ field: "year", maxWidth: 90 },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onCellSelectionChanged(e: unknown) {
console.log(e);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Editing Events Copy Link
Value has changed after editing. Only fires when readOnlyEdit=true. |
Cell selection delete operation (cell clear) has started. |
Cell selection delete operation (cell clear) has ended. |
Cell Selection API Copy Link
The following methods are available on the GridApi for managing cell selection.
Returns the list of selected cell ranges.
The start is the first cell the user clicked on and the end is the cell where the user stopped dragging.
Do not assume that the start cell's index is numerically before the end cell, as the user could have dragged up. |
Adds the provided cell range to the selected ranges.
This keeps any previous ranges. If you wish to only have the new range selected, then call clearCellSelection() first. |
Clears the selected cell ranges. |
Cell ranges are normally bounded by a start and end row. However it is also possible to define a range unbounded by rows (i.e. to contain all rows). When adding an unbounded range via gridApi.addCellRange, do not provide start or end row positions.
Row positions are defined by a row index and pinned. Row indexes are integers starting at zero. Pinned can be either 'top' (row is in pinned top section), 'bottom' (row is in pinned bottom section) or null (row is in the main body). See Row Pinning for information on row pinning.
Ranges are defined by a list of columns. Pass in either a) a list of columns or b) a start and end column and let the grid work out the columns in between. Passing a list of columns instead of a start and end column has the advantage that the columns do not need to be contiguous.

Configuration API Copy Link
If true, only a single range can be selected |
If true the header of cells containing ranges will be highlighted. |
If true, allows selection of a column of cells when clicking the column header. |
Determine the selection handle behaviour. Can be used to configure the range handle and the fill handle.
|
Selection Events Copy Link
A change to cell selection has occurred. |
Fill operation has started. |
Fill operation has ended. |
As an example to illustrate the cellSelectionChanged event, if selecting a range of 5 cells in a row, the user will click the first cell and drag to the last cell. This will result in up to 7 events. The first and last cell in the range will cause two events each. This is due to the first cell firing an event with started=true, finished=true upon mousedown with an additional event started=true, finished=false while in the range, and the last cell firing an event started=false, finished=false as soon as it is in the range and then again started=false, finished=true upon the end of cell selection. All the intermediary events will have one event with both started and finished as false. This is illustrated in the table:
| User action | started | finished |
|---|---|---|
mousedown in first cell | true | true |
mousemove in first cell | true | false |
mousemove in intermediate cells | false | false |
mousemove in final cell | false | false |
mouseup in final cell | false | true |
The example below also illustrates this by logging the event fields in the console:
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 150 },
{ field: "age", maxWidth: 90 },
{ field: "country", minWidth: 150 },
{ field: "year", maxWidth: 90 },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/small-olympic-winners.json",
);
const onCellSelectionChanged = useCallback((e: unknown) => {
console.log(e);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
cellSelection={true}
onCellSelectionChanged={onCellSelectionChanged}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; Editing Events Copy Link
Value has changed after editing. Only fires when readOnlyEdit=true. |
Cell selection delete operation (cell clear) has started. |
Cell selection delete operation (cell clear) has ended. |
Cell Selection API Copy Link
The following methods are available on the GridApi for managing cell selection.
Returns the list of selected cell ranges.
The start is the first cell the user clicked on and the end is the cell where the user stopped dragging.
Do not assume that the start cell's index is numerically before the end cell, as the user could have dragged up. |
Adds the provided cell range to the selected ranges.
This keeps any previous ranges. If you wish to only have the new range selected, then call clearCellSelection() first. |
Clears the selected cell ranges. |
Cell ranges are normally bounded by a start and end row. However it is also possible to define a range unbounded by rows (i.e. to contain all rows). When adding an unbounded range via gridApi.addCellRange, do not provide start or end row positions.
Row positions are defined by a row index and pinned. Row indexes are integers starting at zero. Pinned can be either 'top' (row is in pinned top section), 'bottom' (row is in pinned bottom section) or null (row is in the main body). See Row Pinning for information on row pinning.
Ranges are defined by a list of columns. Pass in either a) a list of columns or b) a start and end column and let the grid work out the columns in between. Passing a list of columns instead of a start and end column has the advantage that the columns do not need to be contiguous.

Configuration API Copy Link
If true, only a single range can be selected |
If true the header of cells containing ranges will be highlighted. |
If true, allows selection of a column of cells when clicking the column header. |
Determine the selection handle behaviour. Can be used to configure the range handle and the fill handle.
|
Selection Events Copy Link
A change to cell selection has occurred. |
Fill operation has started. |
Fill operation has ended. |
As an example to illustrate the cellSelectionChanged event, if selecting a range of 5 cells in a row, the user will click the first cell and drag to the last cell. This will result in up to 7 events. The first and last cell in the range will cause two events each. This is due to the first cell firing an event with started=true, finished=true upon mousedown with an additional event started=true, finished=false while in the range, and the last cell firing an event started=false, finished=false as soon as it is in the range and then again started=false, finished=true upon the end of cell selection. All the intermediary events will have one event with both started and finished as false. This is illustrated in the table:
| User action | started | finished |
|---|---|---|
mousedown in first cell | true | true |
mousemove in first cell | true | false |
mousemove in intermediate cells | false | false |
mousemove in final cell | false | false |
mouseup in final cell | false | true |
The example below also illustrates this by logging the event fields in the console:
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:rowData="rowData"
@cell-selection-changed="onCellSelectionChanged"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 150 },
{ field: "age", maxWidth: 90 },
{ field: "country", minWidth: 150 },
{ field: "year", maxWidth: 90 },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
});
const rowData = ref<IOlympicData[]>(null);
function onCellSelectionChanged(e: unknown) {
console.log(e);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/small-olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
onCellSelectionChanged,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Editing Events Copy Link
Value has changed after editing. Only fires when readOnlyEdit=true. |
Cell selection delete operation (cell clear) has started. |
Cell selection delete operation (cell clear) has ended. |
Cell Selection API Copy Link
The following methods are available on the GridApi for managing cell selection.
Returns the list of selected cell ranges.
The start is the first cell the user clicked on and the end is the cell where the user stopped dragging.
Do not assume that the start cell's index is numerically before the end cell, as the user could have dragged up. |
Adds the provided cell range to the selected ranges.
This keeps any previous ranges. If you wish to only have the new range selected, then call clearCellSelection() first. |
Clears the selected cell ranges. |
Cell ranges are normally bounded by a start and end row. However it is also possible to define a range unbounded by rows (i.e. to contain all rows). When adding an unbounded range via gridApi.addCellRange, do not provide start or end row positions.
Row positions are defined by a row index and pinned. Row indexes are integers starting at zero. Pinned can be either 'top' (row is in pinned top section), 'bottom' (row is in pinned bottom section) or null (row is in the main body). See Row Pinning for information on row pinning.
Ranges are defined by a list of columns. Pass in either a) a list of columns or b) a start and end column and let the grid work out the columns in between. Passing a list of columns instead of a start and end column has the advantage that the columns do not need to be contiguous.